'''
Created on Nov 4, 2015

@author: manju
'''

import os
import sys
import shutil

def main():

    SOURCE = "/data/aad/cssc14/cssc-logs/"
    
    val_call = "./configurators/smac-v2.06.01-master-622/smac-validate --cutoff_time 5000 --trajectoryFile %s --numRun %d --outputFileSuffix csscWorkerValid_mult2 --numValidationRuns 1 --maxTimestamp 172800 --tae CLI --scenarioFile %s --validateOnlyLastIncumbent true --useScenarioOutDir true --outputDirectory ./validate-%s --validateTestInstances %s --waitForPersistedRunCompletion false %s 1> ./log-validate-%s-%d.txt 2>&1"
    def_val = "--includeDefaultAsFirstRandom true --random-configurations 1"
    
    job_list = []
    
    for scen in os.listdir(SOURCE):
        print(scen)
        dir_ = os.path.join(SOURCE, scen)
    
        if not os.path.isdir(dir_) or scen == "backup":
            continue
        
        try:
            os.mkdir(scen)
        except OSError:
            pass
    
        os.chdir(scen)
        
        try:
            os.mkdir("tmp")
        except OSError:
            pass
    
        for f in os.listdir(dir_):
            if os.path.islink(os.path.join(dir_,f)):  # copy all symlinks to scenario files
                try:
                    os.symlink(os.readlink(os.path.join(dir_,f)),f)
                except OSError:
                    pass
            if not f.startswith("log") and f.endswith("txt"):  # copy scenario file
                shutil.copy(os.path.join(dir_,f), ".")
                scen_file = f
            if f.endswith("csv") and not f.startswith("target_algo"):
                shutil.copy(os.path.join(dir_,f), ".")
                
            if f in ["paramils_out","smac-output"] and not os.path.isdir(f):
                shutil.copytree(os.path.join(dir_,f), f)
    
            if f == "run-algo.sh":
                shutil.copy(os.path.join(dir_,f), ".")
    
            configurator = ""
            if "gga" in scen:
                traj_file = "./traj.csv"
                configurator = "gga"
            if "smac" in scen:
                traj_file = "smac-output/CSSC/traj-run-%d.csv"
                configurator = "smac"
            if "paramils" in scen:
                traj_file = "paramils_out/focused-runs2000-runobjruntime-overallobjmean10-maxit200000000-bm2-time300.0-tunerTime172800.0-algoAlgo-traj_%d.csv"
                configurator = "paramils"
                
        if configurator == "gga":
            
            with open("run.sh", "w") as fp:
                fp.write("#!\\bin\\bash\n")
                fp.write("cd %s\n" %(os.path.abspath(os.curdir)))
                val_cal_train = val_call %(traj_file, 1, scen_file, "train", "false", "", "train", 1)
                fp.write("%s\n" %(val_cal_train))
                val_cal_test = val_call %(traj_file, 1, scen_file, "test", "true", "", "test", 1)
                fp.write("%s\n" %(val_cal_test))
            job_list.append("bash %s/run.sh" %(scen))
            
        else:
            
            for i in range(0,4):
                with open("run-%d.sh" %(i), "w") as fp:
                    fp.write("#!\\bin\\bash\n")
                    fp.write("cd %s\n" %(os.path.abspath(os.curdir)))
                    traj_file_i = traj_file %(i)
                    val_cal_train = val_call %(traj_file_i, i, scen_file, "train", "false", "", "train", i)
                    fp.write("%s\n" %(val_cal_train))
                    val_cal_test = val_call %(traj_file_i, i, scen_file, "test", "true", "", "test", i)
                    fp.write("%s\n" %(val_cal_test))
                job_list.append("bash %s/run-%d.sh" %(scen,i))
                    
            if configurator == "smac" and "smac-disc" not in scen:
                with open("run-def.sh", "w") as fp: 
                    fp.write("#!\\bin\\bash\n")
                    fp.write("cd %s\n" %(os.path.abspath(os.curdir)))
                    traj_file_i = traj_file %(1)
                    val_cal_train = val_call %(traj_file_i, 1, scen_file, "default-train", "false", def_val, "train", 1)
                    fp.write("%s\n" %(val_cal_train))
                    val_cal_test = val_call %(traj_file_i, 1, scen_file, "default", "true", def_val, "defaul", 1)
                    fp.write("%s\n" %(val_cal_test))
                job_list.append("bash %s/run-%d.sh" %(scen,i))  

        os.chdir("..")
        
    with open("jobs.txt", "w") as fp:
        fp.write("\n".join(job_list))    


if __name__ == '__main__':
    main()
