#!/bin/python

'''
@author: Marius Lindauer
@license: GPLv3
'''

# sys.argv[1]: directory with scenarios
# reading the scenarios and extracting test and training instances

import os, sys
import numpy

for scen_file in os.listdir(sys.argv[1]):
    scen_file = os.path.join(sys.argv[1], scen_file)
    cnfs = []
    variables = []
    clauses = []
    if os.path.isfile(scen_file):
        with open(scen_file) as fp:
            for line in fp:
                line = line.strip("\n")
                if line.startswith("instance_file"):
                    training_file = line.split("=")[1].strip(" ")
                    with open(training_file) as t_fp:
                        cnfs.extend(t_fp.readlines())
                if line.startswith("test_instance_file"):
                    test_file = line.split("=")[1].strip(" ")
                    with open(test_file) as t_fp:
                        cnfs.extend(t_fp.readlines())
        for cnf in cnfs:
            cnf = cnf.strip("\n")
            cnf = cnf.split()[0] #in case of instance-specific info
            #sprint(cnf)
            with open(cnf) as fp:
                for line in fp:
                    line = line.strip("\n")
                    if line.startswith("p cnf"):
                        stats = line.split()
                        variables.append(int(stats[2]))
                        clauses.append(int(stats[3]))
                        break
    print(scen_file)
    print("Variables: %.0f +- %.0f" %(numpy.mean(variables), numpy.std(variables)))
    print("Clauses: %.0f +- %.0f" %(numpy.mean(clauses), numpy.std(clauses)))
